from math import *
#all the explanation of the classes and variables but the active reinforcement and the post-tensioning load is done in Definitions_no_prestressing

class BeamClass:
    x0 = 0
    y0 = 0
    z0 = 0
    span = 6
    width = 0.4
    depth = 0.6
    name = "Concrete Beam"
    typeOfConcrete = "C45/55"
    pass
Beam = BeamClass()

class SteelPlateClass:
    y0 = Beam.y0
    z0 = Beam.depth
    span = 0.2
    width = Beam.width
    depth = 0.05
    name = "Steel Plate"
    typeOfSteel = "S275"
    pass
SteelPlate = SteelPlateClass()
SteelPlate.x0 = Beam.span / 2 - SteelPlate.span / 2

class PointClass:
        x = Beam.span / 2
        y = Beam.width / 2
        z = Beam.depth + SteelPlate.depth
        name = "Point"
        pass
Point = PointClass

class CoversClass:
    vertical = 0.1
    horizontal = 0.1
    pass
Covers = CoversClass()

class RebarClass:
    distance_between = 0.1
    x = Beam.x0
    y = Covers.horizontal  # initial position in Y axis where the first rebar will be
    z_inferior = Covers.vertical  # position in Z axis where the inferior rebar will be
    z_superior = Beam.depth - Covers.vertical  # position in Z axis where the superior rebar will be
    name = "Rebar"
    young_modulus = 2e+11
    yield_stress = 5e+8
    diametre = 0.012
    name_diametre = "Diametre Rebar"
    pass
Rebar = RebarClass()
Rebar.number_inferior = (ceil(Beam.width / Rebar.distance_between)) - 1  # number of bars in the inferior part
Rebar.number_total = 2 * Rebar.number_inferior  # total number of bars (inferior+superior)

class StirrupsClass:
    distance_between = 0.25
    name = "Stirrup"
    # we define the positions of the points of the polylines
    x = Beam.x0  # this is where the first stirrup will be in the X axis
    y1 = Covers.horizontal
    y2 = Beam.width - Covers.horizontal
    z1 = Covers.vertical
    z2 = Beam.depth - Covers.vertical
    diametre = 0.008
    name_diametre = "Diametre Stirrups"
    pass
Stirrups = StirrupsClass()
Stirrups.number = (int(Beam.span / Stirrups.distance_between)) + 1

class ActiveReinfoClass:
    # we define the cover and the positions of the active rebar
    vertical_cover = 0.25 #we declare the vertical cover so that the vertical rebar doesn't get corroded
    horizontal_cover = 0.1 #we declare the horizontal cover so that the vertical rebar doesn't get corroded
    name = "Active rebar" #we declare the name that all the bars will receive
    young_modulus = 1.9e+11 #value of the young's modulus of the active rebar
    diametre = 0.18 #diametre of the active rebar
    name_diametre = "Diametre Active Reinforcement" #name that the diametre of the active rebar will receive
    pass
ActiveReinfo = ActiveReinfoClass()
#we define all these variables after the class has been declared because some variables included inside are nedeed
ActiveReinfo.y1 = ActiveReinfo.horizontal_cover
ActiveReinfo.y2 = Beam.width / 2
ActiveReinfo.y3 = Beam.width - ActiveReinfo.horizontal_cover
ActiveReinfo.z1_1 = ActiveReinfo.vertical_cover #first layer first point
ActiveReinfo.z1_2 = ActiveReinfo.vertical_cover - 0.07 #first layer second point
ActiveReinfo.z1_3 = ActiveReinfo.vertical_cover - 0.1 #first layer third
ActiveReinfo.z2_1 = Beam.depth / 2 #second layer first point
ActiveReinfo.z2_2 = (Beam.depth / 2) - 0.07 #second layer second point
ActiveReinfo.z2_3 = (Beam.depth / 2) - 0.1 #second layer third point
ActiveReinfo.z3_1 = Beam.depth - ActiveReinfo.vertical_cover #third layer first point
ActiveReinfo.z3_2 = (Beam.depth - ActiveReinfo.vertical_cover) - 0.07 #third layer second point
ActiveReinfo.z3_3 = (Beam.depth - ActiveReinfo.vertical_cover) - 0.1 #third layer third point
ActiveReinfo.x_positions = [0, 1, 2, 3, 4,5]  # we define an array with random numbers(except the first one that has to be a 0)
ActiveReinfo.distance_points = Beam.span / 5  # we divide the lenght of the beam into 5 exact pieces
counter = 1  # we define counter again
for counter in range(1, 6):
    ActiveReinfo.x_positions[counter] = ActiveReinfo.x_positions[counter - 1] + ActiveReinfo.distance_points  # we fill the array declared before with the distances calculated before

class LoadsClass:
    pointload = 1000  #force in Newtons
    pointload_direction = 3 #1 stands for x, 2 for y and 3 for z
    pointload_name = "Point Load" #name of the point load applied
    selfweight_name = "Self weight"#name of the selfweight applied
    tendon_force = 80000 # we define the load that we want to apply to the post-tension
    posttension_name = "Post-tensioning"
    friction_coefficient = 0.65
    pass
Loads = LoadsClass()

class CategoriesClass:
    beams = "Beams"
    plates = "Plates"
    rebar = "Rebar"
    stirrups = "Stirrups"
    prestressing = "Active reinforcement"
    pass
Categories = CategoriesClass()

class MaterialsClass:
    concrete = "Concrete"
    steel = "Steel"
    reinfo_steel = "Reinforcement steel"
    prestress_steel = "Prestressing steel"
    pass
Materials = MaterialsClass()

class SupportsClass:
    name = "Supports"
    x_translation = 0
    y_translation = 0
    z_translation = 1
    x_rotation = 0
    y_rotation = 0
    z_rotation = 0
    pass
Supports = SupportsClass()

class PrincipalAxisClass: #numbers that correspond to the principal axis. Cannot be changed
    x = 1
    y = 2
    z = 3
    pass
PrincipalAxis = PrincipalAxisClass()

class FactorCombinationClass:
    c1 = 1
    c2 = 2
    c3 = 3
#no other combination is needed because the combination of the loads takes place in the Analysis
    pass
FactorCombination = FactorCombinationClass()

class MeshPropertiesClass:
    size = 0.1
    pass
MeshProperties = MeshPropertiesClass()

class AnalysisClass:
    name = "Analysis 1"
    type = "Structural nonlinear"
    factor_and_numberIterations = "4(60)" #the first number is the factor and the one in the parenthesis is the nº of iterations
    number_iterations_calculation = 10
    pass
Analysis = AnalysisClass()



