exec(open('C:/Users/marti/Desktop/Python_Scripts/Definitions_prestressing.py').read()) #we link this document to the one where all the classes and variables are declared

#WE START THE PROGRAM

createBlock(Beam.name, [Beam.x0, Beam.y0, Beam.z0], [Beam.span, Beam.width, Beam.depth]) #we create the beam
createBlock( SteelPlate.name, [ SteelPlate.x0, SteelPlate.y0, SteelPlate.z0 ], [ SteelPlate.span, SteelPlate.width, SteelPlate.depth ] ) #we create the steel plate
createPointBody( Point.name, [ Point.x, Point.y, Point.z ] ) #we create the point in which the load will be applied

projection( "SHAPEFACE", SteelPlate.name, [[ Point.x, Point.y, Point.z ]], [ Point.name ], [ 0, 0, -1 ], True ) #we imprint the point on the steel plate
removeShape( [ Point.name ] ) #we remove the point created before. now it is part of the steel plate

#we create a for loop in order to create the inferior passive reinforcement
counter = 1
for counter in range(1, Rebar.number_inferior+1):
    createLine(Rebar.name + str(counter), [ Rebar.x, Rebar.y, Rebar.z_inferior ], [Beam.span, Rebar.y, Rebar.z_inferior])
    Rebar.y = Rebar.y + Rebar.distance_between

#we create a for loop in order to create the superior passive reinforcement
Rebar.y = Covers.horizontal #we define again the distance of the rebar from the edge to create the rebar in the superior part
for counter in range(Rebar.number_inferior+1, Rebar.number_total+1):
    createLine(Rebar.name + str(counter), [ Rebar.x, Rebar.y, Rebar.z_superior ], [Beam.span, Rebar.y, Rebar.z_superior])
    Rebar.y = Rebar.y + Rebar.distance_between #we separate the bars from one another with the distance settled before by changig the Y position

#we define counter again and create a loop to create the polyline
counter = 1
for a in range(1, Stirrups.number+1):
    createPolyline(Stirrups.name + str(a), [[Stirrups.x, Stirrups.y1, Stirrups.z1], [Stirrups.x, Stirrups.y2, Stirrups.z1], [Stirrups.x, Stirrups.y2, Stirrups.z2], [Stirrups.x, Stirrups.y1, Stirrups.z2]], True )
    Stirrups.x = Stirrups.x + Stirrups.distance_between

#we create the active reinforcement
createCurve(ActiveReinfo.name + str(1), [[ActiveReinfo.x_positions[0], ActiveReinfo.y1, ActiveReinfo.z1_1],[ActiveReinfo.x_positions[1], ActiveReinfo.y1, ActiveReinfo.z1_2],[ActiveReinfo.x_positions[2], ActiveReinfo.y1, ActiveReinfo.z1_3], [ActiveReinfo.x_positions[4], ActiveReinfo.y1, ActiveReinfo.z1_2], [ActiveReinfo.x_positions[5], ActiveReinfo.y1, ActiveReinfo.z1_1]])
createCurve(ActiveReinfo.name + str(2), [[ActiveReinfo.x_positions[0], ActiveReinfo.y3, ActiveReinfo.z1_1],[ActiveReinfo.x_positions[1], ActiveReinfo.y3, ActiveReinfo.z1_2],[ActiveReinfo.x_positions[2], ActiveReinfo.y3, ActiveReinfo.z1_3], [ActiveReinfo.x_positions[4], ActiveReinfo.y3, ActiveReinfo.z1_2], [ActiveReinfo.x_positions[5], ActiveReinfo.y3, ActiveReinfo.z1_1]])
createCurve(ActiveReinfo.name + str(3), [[ActiveReinfo.x_positions[0], ActiveReinfo.y2, ActiveReinfo.z2_1],[ActiveReinfo.x_positions[1], ActiveReinfo.y2, ActiveReinfo.z2_2],[ActiveReinfo.x_positions[2], ActiveReinfo.y2, ActiveReinfo.z2_3], [ActiveReinfo.x_positions[4], ActiveReinfo.y2, ActiveReinfo.z2_2], [ActiveReinfo.x_positions[5], ActiveReinfo.y2, ActiveReinfo.z2_1]])
createCurve(ActiveReinfo.name + str(4), [[ActiveReinfo.x_positions[0], ActiveReinfo.y1, ActiveReinfo.z3_1],[ActiveReinfo.x_positions[1], ActiveReinfo.y1, ActiveReinfo.z3_2],[ActiveReinfo.x_positions[2], ActiveReinfo.y1, ActiveReinfo.z3_3], [ActiveReinfo.x_positions[4], ActiveReinfo.y1, ActiveReinfo.z3_2], [ActiveReinfo.x_positions[5], ActiveReinfo.y1, ActiveReinfo.z3_1]])
createCurve(ActiveReinfo.name + str(5), [[ActiveReinfo.x_positions[0], ActiveReinfo.y3, ActiveReinfo.z3_1],[ActiveReinfo.x_positions[1], ActiveReinfo.y3, ActiveReinfo.z3_2],[ActiveReinfo.x_positions[2], ActiveReinfo.y3, ActiveReinfo.z3_3], [ActiveReinfo.x_positions[4], ActiveReinfo.y3, ActiveReinfo.z3_2], [ActiveReinfo.x_positions[5], ActiveReinfo.y3, ActiveReinfo.z3_1]])


#we rename and create the needed categories
rename( "SHAPESET", "Shapes", Categories.beams ) #we change the name of the folder. from shapes to beam
addSet( "SHAPESET", Categories.plates ) #we add the category for plates
addSet( "SHAPESET", Categories.rebar ) #we add the category for rebar
addSet( "SHAPESET", Categories.stirrups ) #we add the category for stirrups
addSet( "SHAPESET", Categories.prestressing ) #we add the category for active reinforcement

#we move all the elements to their respectives categories
moveToShapeSet( [ SteelPlate.name ], Categories.plates ) #we move the plate from the category "beam" to the category "plates"
#we define counter again and create a loop to move all the rebar to their category
counter = 1
for counter in range(1, Rebar.number_total + 1):
    moveToShapeSet( [ Rebar.name + str(counter) ], Categories.rebar )

#we define counter again and create a loop to move all the stirrups to their category
counter = 1
for counter in range(1, Stirrups.number + 1):
    moveToShapeSet( [ Stirrups.name + str(counter) ], Categories.stirrups )

#we define counter again and create a loop to move all the tendons to their category
counter = 1
for counter in range (1,6):
    moveToShapeSet([ActiveReinfo.name + str(counter)], Categories.prestressing)

#we add the materials that we will deal with
#we add the concrete
addMaterial( Materials.concrete, "CONCDC", "EN1992", [ "TOTCRK" ] ) #we add the material
setParameter( "MATERIAL", Materials.concrete, "EC2CON/NORMAL/CLASS", Beam.typeOfConcrete) #we set the properties of the material
#we add the steel for the plate
addMaterial( Materials.steel, "STEEDC", "EN1993", [] ) #we add the material
setParameter( "MATERIAL", Materials.steel, "EURO93/EN931/GRADE", SteelPlate.typeOfSteel ) #we set the properties of the material
#we add the steel used in the passive reinforcement
addMaterial( Materials.reinfo_steel, "REINFO", "LINEAR", [ "DESIGN" ] ) #we add the material
setParameter( "MATERIAL", Materials.reinfo_steel, "LINEAR/ELASTI/YOUNG", Rebar.young_modulus ) #we set the properties of the material
setParameter( "MATERIAL", Materials.reinfo_steel, "REDESI/YLDSTR", Rebar.yield_stress ) #we set the properties of the material
#we add the steel used in the active reinforcement
addMaterial( Materials.prestress_steel, "REINFO", "LINEAR", [ "NOBOND" ] )
setParameter( MATERIAL, Materials.prestress_steel, "LINEAR/ELASTI/YOUNG", ActiveReinfo.young_modulus )

#we assign the materials to the geometries created before
#we assign the concrete to the beam
setCurrentShapeSet( Categories.beams )
setElementClassType( "SHAPE", [Beam.name], "STRSOL")
assignMaterial(Materials.concrete, "SHAPE", [Beam.name]) #we assign concrete to block1

#we assign the steel to the plate
setCurrentShapeSet( Categories.plates )
setElementClassType( "SHAPE", [ SteelPlate.name ], "STRSOL" )
assignMaterial( Materials.steel, "SHAPE", [ SteelPlate.name ] ) #we assign steel to block 2
#we assign the other steel to the reinforcement (both rebar and stirrups)

#we define a diametre for the rebar
setCurrentShapeSet( Categories.rebar )
addGeometry( Rebar.name_diametre, "RELINE", "REBAR", [] )
setParameter( "GEOMET", Rebar.name_diametre, "REIEMB/RDITYP", "RDIAME" )
setParameter( "GEOMET", Rebar.name_diametre, "REIEMB/DIAMET", Rebar.diametre )

#we define a diametre for the stirrups
setCurrentShapeSet( Categories.stirrups )
addGeometry( Stirrups.name_diametre, "RELINE", "REBAR", [] )
setParameter( "GEOMET", Stirrups.name_diametre, "REIEMB/RDITYP", "RDIAME" )
setParameter( "GEOMET", Stirrups.name_diametre, "REIEMB/DIAMET", Stirrups.diametre )

#we define the geometry of the post-tensioning steel
setCurrentShapeSet( Categories.prestressing )
addGeometry( ActiveReinfo.name_diametre, "RELINE", "REBAR", [] )
setParameter( "GEOMET", ActiveReinfo.name_diametre, "REIEMB/RDITYP", "RDIAME" )
setParameter( "GEOMET", ActiveReinfo.name_diametre, "REIEMB/DIAMET", ActiveReinfo.diametre )

#we define counter again and do a loop to assign the geometry and properties to all the rebar
counter = 1
for counter in range(1, Rebar.number_total+1):
    setReinforcementAspects( [ Rebar.name + str(counter) ] )
    assignMaterial( Materials.reinfo_steel, "SHAPE", [ Rebar.name + str(counter) ] )
    assignGeometry( Rebar.name_diametre, "SHAPE", [ Rebar.name + str(counter) ] )
    resetElementData( "SHAPE", [ Rebar.name + str(counter) ] )
    setReinforcementDiscretization( [ Rebar.name + str(counter) ], "ELEMENT" )

#we define counter again and do a loop to assign the geometry and properties to all the stirrups
counter = 1
for counter in range(counter, Stirrups.number+1):
    setReinforcementAspects( [ Stirrups.name + str(counter)] )
    assignMaterial( Materials.reinfo_steel, "SHAPE", [ Stirrups.name + str(counter) ] )
    assignGeometry( Stirrups.name_diametre, "SHAPE", [ Stirrups.name + str(counter) ] )
    resetElementData( "SHAPE", [ Stirrups.name + str(counter) ] )
    setReinforcementDiscretization( [ Stirrups.name + str(counter) ], "ELEMENT" )

#we define counter again and do a loop to assign the geometry and properties to the post-tensioning steel bars
counter = 1
for counter in range(1, 6):
    setReinforcementAspects( [ ActiveReinfo.name + str(counter) ] )
    assignMaterial( Materials.prestress_steel, "SHAPE", [ ActiveReinfo.name + str(counter) ] )
    assignGeometry( ActiveReinfo.name_diametre, "SHAPE", [ ActiveReinfo.name + str(counter) ] )
    resetElementData( "SHAPE", [ ActiveReinfo.name + str(counter) ] )
    setReinforcementDiscretization( [ ActiveReinfo.name + str(counter) ], "ELEMENT" )

#we define the supports
addSet( "GEOMETRYSUPPORTSET", Supports.name )
createLineSupport( Supports.name, Supports.name )
setParameter( "GEOMETRYSUPPORT", Supports.name, "AXES", [ PrincipalAxis.x, PrincipalAxis.y ] )
setParameter( "GEOMETRYSUPPORT", Supports.name, "TRANSL", [ Supports.x_translation, Supports.y_translation, Supports.z_translation ] )
setParameter( "GEOMETRYSUPPORT", Supports.name, "ROTATI", [ Supports.x_rotation, Supports.y_rotation, Supports.z_rotation ] )
attach( "GEOMETRYSUPPORT", Supports.name, Beam.name, [[Beam.x0, Beam.width / 2, Beam.z0], [Beam.span, Beam.width / 2, Beam.z0]]) #coordinates of the lines in both ends of the beam

#we apply the self-weight
addSet( "GEOMETRYLOADSET", Loads.selfweight_name )
createModelLoad( Loads.selfweight_name, Loads.selfweight_name ) #the first name  is the name of the force and the second the category

#we apply the post-tension load to all the tendons
createBodyLoad( Loads.posttension_name, Loads.posttension_name )
setParameter( "GEOMETRYLOAD", Loads.posttension_name, "LODTYP", "POSTEN" )
setParameter( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/TENTYP", "ONEEND" )
setParameter( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/FORCE1", Loads.tendon_force  )
setParameter( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/SHEAR", Loads.friction_coefficient )
attachTo( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/PNTS1", ActiveReinfo.name + str(1), [[ Beam.span, ActiveReinfo.y1, ActiveReinfo.z1_1 ]] )
attachTo( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/PNTS1", ActiveReinfo.name + str(2), [[ Beam.span, ActiveReinfo.y3, ActiveReinfo.z1_1 ]] )
attachTo( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/PNTS1", ActiveReinfo.name + str(3), [[ Beam.span, ActiveReinfo.y2, ActiveReinfo.z2_1 ]] )
attachTo( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/PNTS1", ActiveReinfo.name + str(4), [[ Beam.span, ActiveReinfo.y1, ActiveReinfo.z3_1 ]] )
attachTo( "GEOMETRYLOAD", Loads.posttension_name, "POSTEN/ONEEND/PNTS1", ActiveReinfo.name + str(5), [[ Beam.span, ActiveReinfo.y3, ActiveReinfo.z3_1 ]] )
#we define the counter again and we attach the post-tensioning load to the tendons
counter = 1
for counter in range (1, 6):
    attach( "GEOMETRYLOAD", Loads.posttension_name, [ ActiveReinfo.name + str(counter) ] )

#we apply the load in the coordinates of the point created before
addSet( "GEOMETRYLOADSET", Loads.pointload_name )
createPointLoad( Loads.pointload_name, Loads.pointload_name )
setParameter( "GEOMETRYLOAD", Loads.pointload_name, "FORCE/VALUE", -Loads.pointload )
setParameter( "GEOMETRYLOAD", Loads.pointload_name, "FORCE/DIRECT", Loads.pointload_direction )
attach( "GEOMETRYLOAD", Loads.pointload_name, SteelPlate.name, [[ Point.x, Point.y, Point.z ]] )

#we define the load combinations
setDefaultGeometryLoadCombinations(  )
addGeometryLoadCombination( "" )

#we mesh the beam and the plate and generate the mesh
setElementSize([Beam.name, SteelPlate.name], MeshProperties.size, -1, True)
setMesherType([Beam.name, SteelPlate.name], "HEXQUAD")
setMidSideNodeLocation([Beam.name, SteelPlate.name], "LINEAR")
generateMesh( [] )

addAnalysis( Analysis.name ) #we create the analysis
addAnalysisCommand( Analysis.name, "NONLIN", Analysis.type ) #we define that the analysis will be nonlinear
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)", Loads.selfweight_name ) #we define the name of the first load phase (self-weight)
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)/LOAD/LOADNR", FactorCombination.c1 ) #we define the load combination in the load-steps

setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT/EXETYP", "LOAD" ) #we create another phase where we will add the post-tensioning
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)", Loads.posttension_name ) #we define the name of the second load phase (post-tensioning)
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/LOAD/LOADNR", FactorCombination.c2 ) #we define the load combination in the load-steps

setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT/EXETYP", "LOAD" ) #we create another phase where we will change the properties of the reinforcement in the middle section
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)", "Bonding to mother element" ) #we give it the name "bonding to the mother element"
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/PHYSIC" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/LOAD/LOADNR", FactorCombination.c1 ) #we select a factorcombination but it doesn't matter which
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/LOAD/STEPS/EXPLIC/SIZES", "0" ) #we give a value equal to 0 because we don't want to make any change to the beam
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/PHYSIC/BOND", True )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/PHYSIC/BOND/REINFO(11)/RNGNRS", "ALL" )
#setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(3)/PHYSIC/BOND/REINFO(9)/RNGNRS", "\"Active rebar2\" \"Active rebar5\" \"Active rebar8\" \"Active rebar11\" \"Active rebar14\"" )#we select the middle sections

setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT/EXETYP", "LOAD" ) #we create another phase where we will add the point-load
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)", Loads.pointload_name ) #we define the name of the third load phase (point-load)
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/ITERAT/MAXITE", Analysis.number_iterations_calculation ) #we define the number of iterations in the calculation
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/ITERAT/CONVER/DISPLA/NOCONV", "CONTIN" ) #we want the analysis to continue even though it doesn't converge
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/ITERAT/CONVER/FORCE/NOCONV", "CONTIN" ) #we want the analysis to continue even though it doesn't converge
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/LOAD/STEPS/EXPLIC/SIZES", Analysis.factor_and_numberIterations )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(4)/LOAD/LOADNR", FactorCombination.c3 ) #we define the load combination in the load-steps


setAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/SELTYP", "USER" ) #we define all the outputs that we want to receive when the analysis is done
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/DISPLA" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRESS" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRAIN(1)/CRACK" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRAIN(2)/CRKWDT" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STATUS(1)/CRACK" )

runSolver(Analysis.name) #we run the analysis
