exec(open('C:/Users/marti/Desktop/Python_Scripts/Definitions_no_prestressing.py').read()) #we link this document to the one where all the classes and variables are declared

#WE START THE PROGRAM

createBlock(Beam.name, [Beam.x0, Beam.y0, Beam.z0], [Beam.span, Beam.width, Beam.depth]) #we create the beam
createBlock( SteelPlate.name, [ SteelPlate.x0, SteelPlate.y0, SteelPlate.z0 ], [ SteelPlate.span, SteelPlate.width, SteelPlate.depth ] ) #we create the steel plate
createPointBody( Point.name, [ Point.x, Point.y, Point.z ] ) #we create the point in which the load will be applied

projection( "SHAPEFACE", SteelPlate.name, [[ Point.x, Point.y, Point.z ]], [ Point.name ], [ 0, 0, -1 ], True ) #we imprint the point on the steel plate
removeShape( [ Point.name ] ) #we remove the point created before. now it is part of the steel plate

#we use a F0R loop in order to create the inferior passive reinforcement
counter = 1
for counter in range(1, Rebar.number_inferior+1):
    createLine(Rebar.name + str(counter), [ Rebar.x, Rebar.y, Rebar.z_inferior ], [Beam.span, Rebar.y, Rebar.z_inferior])
    Rebar.y = Rebar.y + Rebar.distance_between

#we use a FOR loop in order to create the superior passive reinforcement
Rebar.y = Covers.horizontal #we define again the distance of the rebar from the edge
for counter in range(Rebar.number_inferior+1, Rebar.number_total+1):
    createLine(Rebar.name + str(counter), [ Rebar.x, Rebar.y, Rebar.z_superior ], [Beam.span, Rebar.y, Rebar.z_superior])
    Rebar.y = Rebar.y + Rebar.distance_between

#we define the COUNTER again and create a loop to create the polyline
counter = 1
for a in range(1, Stirrups.number+1):
    createPolyline(Stirrups.name + str(a), [[Stirrups.x, Stirrups.y1, Stirrups.z1], [Stirrups.x, Stirrups.y2, Stirrups.z1], [Stirrups.x, Stirrups.y2, Stirrups.z2], [Stirrups.x, Stirrups.y1, Stirrups.z2]], True )
    Stirrups.x = Stirrups.x + Stirrups.distance_between

#we rename and create the needed categories
rename( "SHAPESET", "Shapes", Categories.beams ) #we change the name of the folder. from shapes to beam
addSet( "SHAPESET", Categories.plates ) #we add the category for plates
addSet( "SHAPESET", Categories.rebar ) #we add the category for rebar
addSet( "SHAPESET", Categories.stirrups ) #we add the category for stirrups

#we move all the elements to their respectives categories
moveToShapeSet( [ SteelPlate.name ], Categories.plates ) #we move the plate from the category "beam" to the category "plates"
#we define the COUNTER again and use a FOR loop to move all the lines from the category "beam" to the category "rebar"
counter = 1
for counter in range(1, Rebar.number_total + 1):
    moveToShapeSet( [ Rebar.name + str(counter) ], Categories.rebar )

#we define the COUNTER again and create a FOR loop to move all the lines from the category "beam" to the category "stirrups"
counter = 1
for counter in range(1, Stirrups.number + 1):
    moveToShapeSet( [ Stirrups.name + str(counter) ], Categories.stirrups )

#we add the materials that we will deal with
#we add the concrete
addMaterial( Materials.concrete, "CONCDC", "EN1992", [ "TOTCRK" ] ) #we add the material
setParameter( "MATERIAL", Materials.concrete, "EC2CON/NORMAL/CLASS", Beam.typeOfConcrete) #we set the properties of the material
#we add the steel used in the plate
addMaterial( Materials.steel, "STEEDC", "EN1993", [] ) #we add the material
setParameter( "MATERIAL", Materials.steel, "EURO93/EN931/GRADE", SteelPlate.typeOfSteel ) #we set the properties of the material
#we add the steel used in the reinforcement
addMaterial( Materials.reinfo_steel, "REINFO", "LINEAR", [ "DESIGN" ] ) #we add the material
setParameter( "MATERIAL", Materials.reinfo_steel, "LINEAR/ELASTI/YOUNG", Rebar.young_modulus ) #we set the properties of the material
setParameter( "MATERIAL", Materials.reinfo_steel, "REDESI/YLDSTR", Rebar.yield_stress ) #we set the properties of the material

#we assign the materials to the geometries created before
#we assign the concrete to the beam
setCurrentShapeSet( Categories.beams )
setElementClassType( "SHAPE", [Beam.name], "STRSOL")
assignMaterial(Materials.concrete, "SHAPE", [Beam.name]) #we assign concrete to block1

#we assign the steel to the plate
setCurrentShapeSet( Categories.plates )
setElementClassType( "SHAPE", [ SteelPlate.name ], "STRSOL" )
assignMaterial( Materials.steel, "SHAPE", [ SteelPlate.name ] ) #we assign steel to block 2

#we define a diametre for the rebar
setCurrentShapeSet( Categories.rebar )
addGeometry( Rebar.name_diametre, "RELINE", "REBAR", [] )
setParameter( "GEOMET", Rebar.name_diametre, "REIEMB/RDITYP", "RDIAME" )
setParameter( "GEOMET", Rebar.name_diametre, "REIEMB/DIAMET", Rebar.diametre )

#we define a diametre for the stirrups
setCurrentShapeSet( Categories.stirrups )
addGeometry( Stirrups.name_diametre, "RELINE", "REBAR", [] )
setParameter( "GEOMET", Stirrups.name_diametre, "REIEMB/RDITYP", "RDIAME" )
setParameter( "GEOMET", Stirrups.name_diametre, "REIEMB/DIAMET", Stirrups.diametre )

#we define the COUNTER again and do a FOR loop to assign the geometry and properties to all the passive horizontal rebar
counter = 1
for counter in range(1, Rebar.number_total+1):
    setReinforcementAspects( [ Rebar.name + str(counter) ] )
    assignMaterial( Materials.reinfo_steel, "SHAPE", [ Rebar.name + str(counter) ] )
    assignGeometry( Rebar.name_diametre, "SHAPE", [ Rebar.name + str(counter) ] )
    resetElementData( "SHAPE", [ Rebar.name + str(counter) ] )
    setReinforcementDiscretization( [ Rebar.name + str(counter) ], "ELEMENT" )

#we define the COUNTER again and do a FOR loop to assign the geometry and properties to all the stirrups
counter = 1
for counter in range(counter, Stirrups.number+1):
    setReinforcementAspects( [ Stirrups.name + str(counter)] )
    assignMaterial( Materials.reinfo_steel, "SHAPE", [ Stirrups.name + str(counter) ] )
    assignGeometry( Stirrups.name_diametre, "SHAPE", [ Stirrups.name + str(counter) ] )
    resetElementData( "SHAPE", [ Stirrups.name + str(counter) ] )
    setReinforcementDiscretization( [ Stirrups.name + str(counter) ], "ELEMENT" )

#we define the supports
addSet( "GEOMETRYSUPPORTSET", Supports.name )
createLineSupport( Supports.name, Supports.name )
setParameter( "GEOMETRYSUPPORT", Supports.name, "AXES", [ PrincipalAxis.x, PrincipalAxis.y ] )
setParameter( "GEOMETRYSUPPORT", Supports.name, "TRANSL", [ Supports.x_translation, Supports.y_translation, Supports.z_translation ] )
setParameter( "GEOMETRYSUPPORT", Supports.name, "ROTATI", [ Supports.x_rotation, Supports.y_rotation, Supports.z_rotation ] )
attach( "GEOMETRYSUPPORT", Supports.name, Beam.name, [[Beam.x0, Beam.width / 2, Beam.z0], [Beam.span, Beam.width / 2, Beam.z0]]) #coordinates of the lines in both ends of the beam

#we apply the self-weight
addSet( "GEOMETRYLOADSET", Loads.selfweight_name )
createModelLoad( Loads.selfweight_name, Loads.selfweight_name ) #the first name  is the name of the force and the second the category

#we apply the load in the coordinates of the point created before
addSet( "GEOMETRYLOADSET", Loads.pointload_name )
createPointLoad( Loads.pointload_name, Loads.pointload_name )
setParameter( "GEOMETRYLOAD", Loads.pointload_name, "FORCE/VALUE", -Loads.pointload )
setParameter( "GEOMETRYLOAD", Loads.pointload_name, "FORCE/DIRECT", Loads.pointload_direction )
attach( "GEOMETRYLOAD", Loads.pointload_name, SteelPlate.name, [[ Point.x, Point.y, Point.z ]] )

#we define the load combinations which will be the default ones
setDefaultGeometryLoadCombinations(  )
addGeometryLoadCombination( "" )

#we mesh the beam and the plate and generate the mesh
setElementSize([Beam.name, SteelPlate.name], MeshProperties.size, -1, True)
setMesherType([Beam.name, SteelPlate.name], "HEXQUAD")
setMidSideNodeLocation([Beam.name, SteelPlate.name], "LINEAR")
generateMesh( [] )

#we set the properties of the analysis and execute it
addAnalysis( Analysis.name ) #we create the analysis
addAnalysisCommand( Analysis.name, "NONLIN", Analysis.type ) #we define that the analysis will be nonlinear
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)", Loads.selfweight_name ) #we define the name of the first load phase (self-weight)
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(1)/LOAD/LOADNR", FactorCombination.c1 ) #we define the load combination in the load-steps

setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT/EXETYP", "LOAD" ) #we create another phase where we will add the point-load
renameAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)", Loads.pointload_name ) #we define the name of the third load phase (point-load)
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/ITERAT/MAXITE", Analysis.number_iterations_calculation ) #we define the number of iterations in the calculation
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/ITERAT/CONVER/DISPLA/NOCONV", "CONTIN" ) #we want the analysis to continue even though it doesn't converge
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/ITERAT/CONVER/FORCE/NOCONV", "CONTIN" ) #we want the analysis to continue even though it doesn't converge
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/LOAD/STEPS/EXPLIC/SIZES", Analysis.factor_and_numberIterations )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/LOAD/LOADNR" )
setAnalysisCommandDetail( Analysis.name, Analysis.type, "EXECUT(2)/LOAD/LOADNR", FactorCombination.c2 ) #we define the load combination in the load-steps

setAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/SELTYP", "USER" ) #we define all the outputs that we want to receive when the analysis is done
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/DISPLA" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRESS" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRAIN(1)/CRACK" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STRAIN(2)/CRKWDT" )
addAnalysisCommandDetail( Analysis.name, Analysis.type, "OUTPUT(1)/USER/STATUS(1)/CRACK" )

runSolver(Analysis.name) #we run the analysis

